/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.awk.builtin;

import net.morilib.awk.io.AwkFiles;
import net.morilib.awk.namespace.AwkNamespace;
import net.morilib.awk.strftime.Strftime;
import net.morilib.awk.value.AwkString;
import net.morilib.awk.value.AwkUndefined;
import net.morilib.awk.value.AwkValue;

public class AwkStrftime extends AwkBinaryArgs {

	private static final String DEFAULT = "%a %b %d %H:%M:%S %Z %Y";

	protected AwkStrftime() {
		super("strftime");
	}

	@Override
	public AwkValue apply(AwkNamespace ns, AwkFiles o, AwkValue a1,
			AwkValue a2) {
		String f, r;
		long l;

		f = a1 instanceof AwkUndefined ? DEFAULT : a1.toString(ns);
		l = a2 instanceof AwkUndefined ?
				System.currentTimeMillis() :
					a2.toInteger().longValue() * 1000;
		r = Strftime.getInstance().format(f, new java.util.Date(l));
		return AwkString.valueOf(r);
	}

}
